#pragma once

#include "SystemFunctions.h"
#include "ManagedRTValue.h"

using namespace System;
using namespace System::Collections::Generic;

namespace PWSPlugin
{
	public ref class PluginFunctions
	{
	public:
		delegate void Proc(List<ManagedRTValue^>^, ManagedRTValue^, SystemFunctions^);

	private:
		Dictionary<DWORD, Proc^> functions;

	public:
		PluginFunctions();

		void Add(TPWPInstance*, String^, Proc^, String^);
		bool Exists(DWORD);
		void Call(SystemFunctions^, DWORD, List<ManagedRTValue^>^, ManagedRTValue^);
	};
}

