/**
* Chararina{̂Ƃ̃vOCC^[tF[X
*/
#include "stdafx.h"
#include "pwsplugin.h"
#include "PluginInterface.h"

#include <msclr/marshal.h>
using namespace msclr::interop;

using namespace PWSPlugin;

// VXe֐̍\
TPWPFunctions g_pwpfunc_t;

/**
* Dexport֐(TPWCPluginProc2^)
* PWPRegisterAyaoriFunc2()œo^
*
* Chararina{̂̃vOC֐Ăяo͑SċʂĂ̊֐Ŏ󂯁C
* instance->pdataparam̑gݍ킹łǂ̊֐ĂԂ߂
*/
void __stdcall PWCPluginProc2(TPWPInstance* instance, const char* pcArgType, IRTValue** pArgs, int nArg, IRTValue* pRetVal, DWORD param)
{
	System::Diagnostics::Debug::WriteLine(__FUNCTIONW__ + ": called");
	PWSPlugin::PluginInterface::CallPluginFunction(instance, pcArgType, pArgs, nArg, pRetVal, param);
}

void PWPInvokeProc(TPWPInstance* instance, exit_state_t state, DWORD style, char* pcType, char* pcFname, IRTValue* pRetval, DWORD param)
{
	System::Diagnostics::Debug::WriteLine(__FUNCTIONW__ + ": called");
	PWSPlugin::PluginInterface::CallInvokeCallback(instance, state, style, pcType, pcFname, pRetval, param);
}

void __stdcall PWCTimerProc(TPWPInstance* instance, TPWPTimerHandle handle, DWORD param)
{
	System::Diagnostics::Debug::WriteLine(__FUNCTIONW__ + ": called");
	PWSPlugin::PluginInterface::CallTimerProc(instance, handle, param);
}

void __stdcall PWCMenuProc(TPWPInstance* instance, const char* item)
{
	System::Diagnostics::Debug::WriteLine(__FUNCTIONW__ + ": called");
	PWSPlugin::PluginInterface::CallMenuProc(instance, item);
}

int __stdcall PWCSynchronizeProc(TPWPInstance *instance, DWORD param)
{
	System::Diagnostics::Debug::WriteLine(__FUNCTIONW__ + ": called");
	return PWSPlugin::PluginInterface::CallSynchronizeProc(instance, param);
}

/**
* vOC{̂烍[hƂ
*
* @param major  Chararina{̂̃W[o[W(3.33  3)
* @param minor  Chararina{̂̃}Ci[o[W(3.33  33)
* @param substr Chararina{̂̃o[WTu(3.33  )
* @param p      VXe֐̍\
*
* @retval TRUE  vOCgݍ
* @retval FALSE vOCgݍ܂Ȃ
*/
BOOL Initialize(int major, int minor, const char *substr, const struct TPWPFunctions *pfunc)
{
	if (major < 3)
	{
		return FALSE;
	}

	// VXe֐\̂Rs[
	unsigned int sz = sizeof(TPWPFunctions);
	memset(&g_pwpfunc_t, 0, sizeof(TPWPFunctions));
	if (pfunc->size < sz)
	{
		sz = pfunc->size;
	}
	memcpy(&g_pwpfunc_t, pfunc, sz);

	return TRUE;
}

/**
* vOCCX^X(1LN^1)
*
* @param instance vOCCX^X
* @param vendor   LN^̃x_[R[h
* @param type     LN^̌^
*
* @retval 1 
* @retval 0 s
*/
extern "C" __declspec(dllexport) int __stdcall
PWCNewInstance(TPWPInstance *instance, const char *vendor, const char *type)
{
	if (0 == PWSPlugin::PluginInterface::NewPluginHost(instance, vendor, type))
	{
		return 0;
	}

	return 1;
}


/**
* vOCCX^XjƂ
*
* @param instance vOCCX^X
*/
extern "C" __declspec(dllexport) void __stdcall
PWCDestroyInstance(TPWPInstance *instance)
{
	PWSPlugin::PluginInterface::DestroyPluginHost(instance);
}


/**
* vOCA[hƂ
*/
extern "C" __declspec(dllexport) void __stdcall
PWCDestroy()
{
}

/* ----------------------------------------------------------------------- */

void PluginInterface::SetPluginAssembly(const char* assembly)
{
	PluginInterface::assemblyName = marshal_as<String^>(assembly);
}

/**
 * vOCCX^X𐶐
 *
 * @retval 1 
 * @retval 0 s
 *
 * @note LN^ɋN瓯ɕʃXbhĂяôH
 */
int PluginInterface::NewPluginHost(TPWPInstance* instance, const char* vendor, const char* type)
{
	System::Diagnostics::Debug::WriteLine(__FUNCTIONW__ + " called");

	if (nullptr == PluginInterface::plugin)
	{
		try
		{
			char dest[MAX_PATH];
			g_pwpfunc_t.PWPGetPluginFolder(instance, dest);

			// TODO ǂݍރAZu̖Owł悤ɂ
			System::Reflection::Assembly^ assembly = System::Reflection::Assembly::LoadFrom(marshal_as<String^>(dest) + PluginInterface::assemblyName);
			//for each (Type^ t in this->pluginAsm->GetTypes())
			//{
			//	System::Diagnostics::Debug::WriteLine(t->ToString());
			//}
			PluginInterface::plugin = safe_cast<PWSPlugin::IPlugin^>(
				assembly->CreateInstance(
					"PWSPlugin.Plugin",
					false,
					System::Reflection::BindingFlags::CreateInstance,
					nullptr,
					nullptr,
					nullptr,
					nullptr
				)
			);
		}
		catch (Exception^ e)
		{
			System::Diagnostics::Debug::WriteLine(e);
			return 0;
		}
	}

	instance->pdata = (void*)new DWORD;
	if (0 == instance->pdata)
	{
		// mۂłȂH
		System::Diagnostics::Debug::WriteLine(__FUNCTIONW__ + " new DWORD failed");
		return 0;
	}

	DWORD id = 0xffffffff;
	for (DWORD i = 0; i < 0xfffffffe; i++)
	{
		if (!PluginInterface::pInsts.ContainsKey(i))
		{
			id = i;
			break;
		}
	}
	if (0xffffffff == id)
	{
		return 0;
	}

	System::Diagnostics::Debug::WriteLine(__FUNCTIONW__ + " creating new instance with id = " + id);

	*((DWORD*)(instance->pdata)) = id;
	PluginHost^ pinst = gcnew PluginHost(PluginInterface::plugin, instance);

	try
	{
		PluginInterface::pInsts.Add(id, pinst);
	}
	catch (ArgumentException^ e)
	{
		// TODO
		System::Diagnostics::Debug::WriteLine(e);
	}

	return 1;
}

void PluginInterface::DestroyPluginHost(TPWPInstance* instance)
{
	DWORD id = *((DWORD*)(instance->pdata));

	if (PluginInterface::pInsts.ContainsKey(id))
	{
		PluginInterface::pInsts[id]->~PluginHost();
		PluginInterface::pInsts.Remove(id);
	}

	System::Diagnostics::Debug::WriteLine(__FUNCTIONW__ + " destroying instance with id = " + id);

	// NewPluginHostŊmۂ̉
	delete instance->pdata;
}

void PluginInterface::CallPluginFunction(TPWPInstance *instance, const char *pcArgType, IRTValue **pArgs, int nArg, IRTValue *pRetVal, DWORD param)
{
	if (!PluginInterface::PluginHostExists(instance))
	{
		return;
	}

	// E߂l}l[WIuWFNgŃbv
	List<ManagedRTValue^>^ args = gcnew List<ManagedRTValue^>;

	for (int i = 0; i < nArg; i++)
	{
		ManagedRTValue^ value = gcnew ManagedRTValue(pArgs[i]);
		args->Add(value);
	}

	ManagedRTValue^ retVal = gcnew ManagedRTValue(pRetVal);

	// YPluginHostCallPluginFunctionĂ
	PluginInterface::GetPluginHost(instance)->Callback_PluginFunction(instance, args, retVal, param);
}

void PluginInterface::CallTimerProc(TPWPInstance *instance, TPWPTimerHandle handle, DWORD param)
{
	if (!PluginInterface::PluginHostExists(instance))
	{
		return;
	}

	// YPluginHostCallTimerProcĂ
	PluginInterface::GetPluginHost(instance)->Callback_Timer(instance, handle, param);
}

void PluginInterface::CallInvokeCallback(TPWPInstance* instance, exit_state_t state, DWORD style, char* pcType, char* pcFname, IRTValue* pRetval, DWORD param)
{
	if (!PluginInterface::PluginHostExists(instance))
	{
		return;
	}

	ManagedRTValue^ retVal = gcnew ManagedRTValue(pRetval);

	// YPluginHostCallTimerProcĂ
	PluginInterface::GetPluginHost(instance)->Callback_Invoke(instance, state, retVal, param);
}

void PluginInterface::CallMenuProc(TPWPInstance* instance, const char* item)
{
	if (!PluginInterface::PluginHostExists(instance))
	{
		return;
	}

	marshal_context ctx;

	// YPluginHostCallTimerProcĂ
	PluginInterface::GetPluginHost(instance)->Callback_Menu(instance, ctx.marshal_as<String^>(item));
}

int PWSPlugin::PluginInterface::CallSynchronizeProc(TPWPInstance* instance, DWORD param)
{
	if (!PluginInterface::PluginHostExists(instance))
	{
		return 0xffffffff;
	}

	return PluginInterface::GetPluginHost(instance)->Callback_Synchronize(instance, param);
}

bool PluginInterface::PluginHostExists(TPWPInstance* instance)
{
	DWORD id = *((DWORD*)(instance->pdata));

	if (!PluginInterface::pInsts.ContainsKey(id))
	{
		return false;
	}

	return true;
}

PluginHost^ PluginInterface::GetPluginHost(TPWPInstance* instance)
{
	DWORD id = *((DWORD*)(instance->pdata));

	if (!PluginInterface::pInsts.ContainsKey(id))
	{
		return nullptr;
	}

	System::Diagnostics::Debug::WriteLine(__FUNCTIONW__ + " got plugin host with id = " + id);
	return PluginInterface::pInsts[id];
}
