#pragma once

#include "pwsplugin.h"
#include "PluginMenuItem.h"

using namespace System;
using namespace System::Collections::Generic;

namespace PWSPlugin
{
	public ref class PluginMenu
	{
	internal:
		TPWPInstance* instance;

	public:

	private:
		Dictionary<String^, PluginMenuItem^> items;

	public:

		enum class Style {
			Default = MS_NORMAL,
			Group = MS_GROUP,
			Separator = MS_SEPARATOR,
		};

		PluginMenu();
		void UpdateInstance(TPWPInstance*);

		PluginMenuItem^ Add(String^, Style, int, PluginMenuItem::Proc^);
		PluginMenuItem^ Insert(String^, String^, Style, int, PluginMenuItem::Proc^);
		PluginMenuItem^ Rename(PluginMenuItem^, String^);
		bool Delete(String^);

		String^ GetSetupMenuName();

		void Call(String^);
	};
}

