#pragma once

#include "pwsplugin.h"
#include "SystemFunctions.h"

namespace PWSPlugin
{
	public ref class PluginTimer
	{
	public:
		delegate void Proc(SystemFunctions^);

	private:
		TPWPTimerHandle handle;
		Proc^ timerProc;

	public:
		enum class Mode {
			Oneshot = TM_ONESHOT,
			Interval = TM_INTERVAL,
		};
		PluginTimer(TPWPTimerHandle, Proc^);
		void Call(SystemFunctions^);
		int Destroy();
		int Start();
		int Stop();
		int ResetInterval(int);
	};
}
